Attribute VB_Name = "cs8130"
'   Stand: 13.06.1999 ; verndert von ct/as
'   ----------------------------------------------------------------------
'
'   NoAd: Keine Werbung auf dem Videorecorder: PC Steuerung
'   Copyright (C) 1999 Peter Richert (Richert@FH-Muenster.DE)
'
'   Telefon +49 2551 9-62125, Fax -62391
'
'   Fachhochschule Mnster, Fachbereich Elektrotechnik
'   eLKaTe - Labor Kommunikationstechnik
'   Stegerwaldstrasse 39, 48565 Steinfurt, GERMANY
'
'   ----------------------------------------------------------------------
'   This program is free software; you can redistribute it and/or modify
'   it under the terms of the GNU General Public License as published by
'   the Free Software Foundation; either version 2 of the License, or
'   (at your option) any later version.
'
'   This program is distributed in the hope that it will be useful,
'   but WITHOUT ANY WARRANTY; without even the implied warranty of
'   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'   GNU General Public License for more details.
'
'   You should have received a copy of the GNU General Public License
'   along with this program; if not, write to the Free Software
'   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'   ----------------------------------------------------------------------
'


     
 


'Konstanten der Fernsteuerungen




Public Sub InitCS8130()
Dim vCode$, fCode$
Taste_gedrckt$ = "01"

'Komando-Modus im Infrarotsender einschalten
Call Kommando_Mode_an_IC(True)

'Die Register im Infrarotsender werden initialisiert
Call Kommando_an_IC_senden("11010000")  'Shadow-Bit rcksetzen im Control Register #3
                                            'Register 0-15 werden angesprochen
    
'ControlRegister #1
Call Kommando_an_IC_senden("00001001") 'Transmitter enabled, Echo enabled
    
'Transmit Mode Register #1
Call Kommando_an_IC_senden("00100101")  'TV remote mode enabled,Amplitude modulated carrier modulation
    
'Transmit Mode Register #2
Call Kommando_an_IC_senden("00110110")  'Bits are trandmitted based on TxD, 8 Bits
    
'Output Power Register
Call Kommando_an_IC_senden("01000011")  'Both LED1C and LED2C enabled
    
'Modulator Divider Register #1 & #2
Call Kommando_an_IC_senden("10100101")  'LSB
Call Kommando_an_IC_senden("10110110")  'MSB ;auf 36 kHz einstellen
    
Call Kommando_an_IC_senden("11010001")  'Shadow bit setzen im Control Register #3
                                            'Register 16-31 werden angesprochen
    
'TV Remote Transmit Bit Rate Divider Register #1 & #2
Call Kommando_an_IC_senden("00111101") '
Call Kommando_an_IC_senden("01001100") '1120 bps
    
'Control Register #4
'Call Kommando_an_IC_senden("01010010")  'If crystal ist used, disable clock output driver (Hi-Z)
                                               'Nur Sicherheitshalber, um berschwinger zu vermeiden
    
Call Kommando_an_IC_senden("11010000")  'Shadow-Bit rcksetzen im Control Register #3
                                                'Register 0-15 werden angesprochen
'Programmierung des IC's beendet
'Komando-Modus im Infrarotsender ausschalten

Call Kommando_Mode_an_IC(False)
vCode$ = ReadInistring("CS8130", "VCODE", "RC-5")
fCode$ = ReadInistring("CS8130", "FCODE", "RC-5")


End Sub
Function Bin(ByVal x As Byte) As String
Dim s$
s$ = ""
For i% = 1 To 8

If x >= 128 Then
  s$ = "1" & s$
Else: s$ = "0" & s$
End If
x = (x And 127) * 2
Next i%
Bin = s$

End Function

Public Sub CS8130send(IRcommand As InfrarotBefehl)



'enthlt 28 Bit (Biphase codierte 14 Bit !)+ 4x"1111" zum Auffllen = 32 Zeichen
Befehl$ = ConstructRC5(IRcommand) & "1111"
'Befehl$ = "1010" & Taste_Gedrckt_Bi$ & Video_Fernseh_Bi$ & Kommando_Bi$ & "1111"

Dim a(3)


    For m = 0 To 3

        a(m) = 0
        For n = 0 To 7
          a(m) = a(m) + (Val(Mid$(Befehl$, n + 1 + (8 * m), 1)) * (2 ^ n))
'          a = a + (Val(Mid$(Befehl$, n + 1 + (8 * m), 1)) * (2 ^ (7 - n)))
        Next n
    
    Next m
    Debug.Print Bin(a(0)); Bin(a(1)); Bin(a(2)); Bin(a(3))
    For Anzahl_Sendungen = 1 To 2
        
        Form1.MSComm1.Output = Chr$(a(0)) + Chr$(a(1)) + Chr$(a(2)) + Chr$(a(3))
    
    Next Anzahl_Sendungen


End Sub

Private Sub Kommando_Mode_an_IC(ByVal Status As Boolean)

If (Status) Then
    Form1.MSComm1.RTSEnable = True ' Chip Reset setzen
    Form1.MSComm1.RTSEnable = False ' Chip Normal Operation setzen
    
    Form1.MSComm1.DTREnable = True ' Chip auf Steuerempfang (D/C_ auf low) setzen
Else
    ' Zeitschleife damit das Signal DTR nicht zu frh wechselt
    Y = 0
    For x = 0 To 1000
        Y = Y + 1
    Next x
    
    Form1.MSComm1.DTREnable = False  ' Chip auf Datenempfang (D/C_ auf high) setzen
End If

End Sub
Private Sub Kommando_an_IC_senden(ByVal Kommando$)

Dim Bit(7) As Byte
Dim Summe As Byte

For n = 0 To 7
    Bit(n) = ((Val(Mid$(Kommando$, (8 - n), 1))) * (2 ^ n))
    Summe = Summe + Bit(n)
Next n

'Form1.MSComm1.DTREnable = False ' Chip auf Steuerempfang (D/C_ auf low) setzen
Form1.MSComm1.Output = Chr$(Summe)
'Form1.MSComm1.DTREnable = True  ' Chip auf Datenempfang (D/C_ auf high) setzen

End Sub

